﻿using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Audio;
using dahtd4ever.GameScreens;

namespace dahtd4ever.GameScreens
{
    public enum MenuState
    {
        Main
    }

    public class Menu
    {
        Game1 game;

        List<Text> menuItems;
        Text activeItem;
        int selection;

        SoundEffect select;
        SoundEffect enter;
        SoundEffect Backsnd;
        SoundEffectInstance BacksndIns;
        String menuTxt = "DAHTD 4EVER!";
        Vector2 titlePos = new Vector2(100, 50);

        public Menu(Game1 game)
        {
            this.game = game;

            #region Menu Items
            menuItems = new List<Text>();
            menuItems.Add(new Text(game, "Neues Spiel", new Vector2(255, 160), true));
            menuItems.Add(new Text(game, "Spiel fortsetzen", new Vector2(255, 200), true));
            menuItems.Add(new Text(game, "Level Auswahl", new Vector2(255, 240), true));
            menuItems.Add(new Text(game, "Beenden", new Vector2(255, 280), true));
            #endregion
            selection = 0;

            select = game.Content.Load<SoundEffect>("Sound\\Select");
            enter = game.Content.Load<SoundEffect>("Sound\\keyboard-click");

            Backsnd = game.Content.Load<SoundEffect>("Sound\\trololo 8bit");
            BacksndIns = Backsnd.CreateInstance();
            BacksndIns.IsLooped = true;
        }

        public void Update(GameTime gTime)
        {
            BacksndIns.Play();

            if (ScreenManager.keyboard.MenuUp)
            {
                select.Play();

                if (selection == 0)
                    selection = 3;
                else
                    selection--;
            }
            else if (ScreenManager.keyboard.MenuDown)
            {
                select.Play();

                if (selection == 3)
                    selection = 0;
                else
                    selection++;
            }

            else if (ScreenManager.keyboard.MenuSelect)
            {
                enter.Play();
                ScreenManager.lastState = GameState.Menu;

                switch (selection)
                {
                    case 0: ScreenManager.gameState = GameState.Play;
                        BacksndIns.Stop();
                        ScreenManager.newGame = true;
                        break;

                    case 2: ScreenManager.gameState = GameState.Levelauswahl;
                        break;
                    case 3: game.Exit();
                        break;
                }
            }

            activeItem = menuItems[selection];

            foreach (Text t in menuItems)
            {
                if (t == activeItem)
                    t.setBubble(true);
                else
                    t.setBubble(false);
                t.update(gTime);
            }
        }


        public void Draw()
        {
            game.spriteBatch.Begin();
            titlePos.X = (game.GraphicsDevice.Viewport.Width / 2 - game.font1.MeasureString(menuTxt).X / 2);
            game.spriteBatch.DrawString(game.font1, menuTxt, titlePos, Color.White);
            game.spriteBatch.End();

            foreach (Text t in menuItems)
                t.draw();
        }        
    }
}
